using System;
using FitConnect;
using FitConnect.Exceptions;
using FitConnect.Models;
using FluentAssertions;
using NUnit.Framework;

namespace IntegrationTests.Sender;

[TestFixture]
public class SenderTestUnhappyPath : SenderTestBase {
    // [Test]
    // public void WithDestination_CompletelyWrong_ShouldThrowArgumentException() {
    //     Assert.Throws<ArgumentException>(() => {
    //             SubmissionBuilder.SetDestination("This is very wrong");
    //         })!
    //         .Message.Should().Be("The destination must be a valid GUID");
    // }

    [Test]
    public void WithData_DataIsInvalidJson_ShouldThrowArgumentException() {
        Assert.Throws<FitConnectSenderException>(() => {
                SendableSubmission.Builder().SetDestination(DestinationId)
                    .SetServiceType("urn:de:fim:leika:leistung:00000000000000", "Name")
                    .SetJsonData("This is very wrong", new Uri("https://www.example.com"))
                    .AddAttachments(Attachment.FromPath("Test.pdf", "application/pdf",fileName: "Test PDF"));
            })!
            .Message.Should().Be("The data must be valid JSON string");
    }
}
